/***************************************************************************
                          sqlgui.cpp  -  description
                             -------------------
    begin                : Mon Apr 29 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <iostream>
#include <iomanip>

#include <qwidget.h>
#include <qframe.h>
#include <qstringlist.h>
#include <qvaluelist.h> 
#include <qsizepolicy.h>
#include <qmap.h>
#include <qwhatsthis.h>
#include <qlayout.h>
#include <qevent.h> 
#include <qpixmap.h> 
#include <qtabwidget.h>
#include <qptrlist.h> 
#include <qtoolbar.h>
#include <qdir.h>
#include <qtooltip.h>

#include <kiconloader.h>
#include <kstddirs.h>
#include <kapplication.h>
#include <kaction.h>
#include <klocale.h>
#include <kfiledialog.h>
#include <kdebug.h>
#include <kcmdlineargs.h>
#include <klibloader.h>
#include <kaboutdata.h>
#include <kstatusbar.h>
#include <kmenubar.h>
#include <ktoolbar.h>
#include <kiconview.h>
#include <kstandarddirs.h>

#include <kparts/part.h>
#include <kparts/mainwindow.h>
#include <kparts/factory.h>
#include <kparts/genericfactory.h>
#include <kparts/browserextension.h>
#include <kparts/partmanager.h>

#include <sqlgui/sqlgui_part.h>

#include "sqlgui.h"
using namespace std;

Shell::Shell()
{
	//  setXMLFile( "/home/marcus/sqlgui/sqlgui/sqlguiui.rc" );
	setXMLFile( "sqlguiui.rc" );

	KAction * paQuit = new KAction( i18n( "&Quit" ), "exit", 0, this, SLOT( slotFileQuit() ), actionCollection(), "file_quit" );
	KAction * fileNewWindow = new KAction(i18n("New Window"), "filenew", 0, this, SLOT(slotFileNewWindow()), actionCollection(),"file_new_window");
	KAction * fileNewConnection = new KAction(i18n("Add Server-Tab"), "filenew", 0, this, SLOT(slotFileNewConnection()), actionCollection(),"file_new_connection");
	fileRemoveConnection = new KAction(i18n("Remove Server-Tab"), "fileclose", 0, this, SLOT(slotRemoveActiveTab()), actionCollection(),"file_remove_connection");

	fileRemoveConnection->setEnabled( false );

	config = new KConfig( "sqlguirc", false, true, "config");

	//  mbar = ((KMainWindow*)this)->menuBar();
	sbar = ((KMainWindow*)this)->statusBar();

	// Username:   User, ID 2, Host, ID 3, Message, ID 1,
	sbar->insertItem("No user", 2, 0, true);
	sbar->insertItem("No host", 3, 0, true);
	sbar->insertItem("", 1, 1, false);

	readOptions();

	// Bilders:
	mysqlon = new QPixmap();
	mysqloff = new QPixmap();
	pgsqlon = new QPixmap();
	pgsqloff = new QPixmap();

	KStandardDirs * kdedirs = new KStandardDirs();

	QString mon  = kdedirs->findResource("data", "sqlgui/sqlgui-mysql-on.png");
	QString moff = kdedirs->findResource("data", "sqlgui/sqlgui-mysql-off.png");
	QString pon  = kdedirs->findResource("data", "sqlgui/sqlgui-postgresql-on.png");
	QString poff = kdedirs->findResource("data", "sqlgui/sqlgui-postgresql-off.png");

	if(mysqlon->load( mon )){
		// std::cout << "Image loaded: sqlgui-mysql-on.png" << endl;
	} else {
		// std::cout << "Image not loaded: sqlgui-mysql-on.png" << endl;
	}
	if(mysqloff->load( moff )){
		// std::cout << "Image loaded: sqlgui-mysql-on.png" << endl;
	} else {
		// std::cout << "Image not loaded: sqlgui-mysql-on.png" << endl;
	}

	if(pgsqlon->load( pon )){
		// std::cout << "Image loaded: sqlgui-postgresql-on.png" << endl;
	} else {
		// std::cout << "Image not loaded: sqlgui-postgresql-on.png" << endl;
	}
	if(pgsqloff->load( poff )){
		// std::cout << "Image loaded: sqlgui-postgresql-on.png" << endl;
	} else {
		// std::cout << "Image not loaded: sqlgui-postgresql-on.png" << endl;
	}

	// Part-Zeuch:
	m_manager = new KParts::PartManager( this );
	connect( m_manager, SIGNAL( activePartChanged( KParts::Part * ) ), this, SLOT( createGUI( KParts::Part * ) ) );
	m_manager->setSelectionPolicy( KParts::PartManager::Direct );

	readOptions();

	int x = size().width();
	int z = size().height();
	z = z - sbar->height();

	//  // std::cout << "x " << x << endl;
	//  // std::cout << "z " << z << endl;

	m_splitter = new QSplitter( this );

	hosts = new KIconView( m_splitter, "Hosts" );

	QWhatsThis::add(  m_splitter, i18n( "SglGui" ) );

	tab = new QTabWidget( m_splitter );
	tab->setSizePolicy( QSizePolicy( QSizePolicy::Expanding, QSizePolicy::Expanding ) );
	QWhatsThis::add(  tab, i18n( "All connections are listed here." ) );

	connect( tab, SIGNAL( currentChanged( QWidget* ) ), this, SLOT( slotTabClicked( QWidget* ) ) );

	hosts->resize( 150, z);
	hosts->setMode( KIconView::Execute );
	hosts->setArrangement( QIconView::TopToBottom );
	hosts->setAutoArrange( true );
	hosts->setResizeMode( QIconView::Adjust );
	hosts->setSelectionMode( QIconView::NoSelection );
	hosts->setSorting( true );
	hosts->setItemsMovable( false );
	hosts->arrangeItemsInGrid( true );
	QWhatsThis::add( hosts, i18n( "This is a list of all recently connected hosts." ) );

	connect( hosts, SIGNAL( executed( QIconViewItem* ) ), this, SLOT( slotOpenRequest( QIconViewItem* ) ) );

	QValueList<int> breitenangabe;
	breitenangabe.append(120);
	breitenangabe.append( size().width() - 120 );
	m_splitter->setSizes( breitenangabe );
	m_splitter->setResizeMode( hosts, QSplitter::KeepSize );
	m_splitter->setResizeMode( tab, QSplitter::Stretch );

	m_splitter->show();

	enableRecentHosts();

	// Timer, der alle 10 Sekunden die Serverliste aktualisiert.
	// Dadurch knnen die geffneten Server grn, die anderen rot dargestellt werden.
	int reloadTimer = startTimer( 10000 );  // every 10 seconds reread hosts...

	setCentralWidget( m_splitter );
	createGUI( NULL );
	expandToolBar();

}

Shell::~Shell(){
	saveOptions();
	SqlGuiPart *sql;
	for ( sql = partList.first(); sql; sql = partList.next() ){
		if(sql){
			m_manager->removePart( sql );
			delete sql;
		}
	}
}

void Shell::openURL( const KURL & url ) {
	// Nur ein Part:
	//  m_sqlguipart->openURL( url );

	// Mehrere Parts und erster Part leer
	( (KParts::ReadOnlyPart*)  m_manager->activePart()  )->openURL( url );

}

void Shell::slotSetHost( QString h ) {
	QString *t = new QString( i18n(" Host: ") );
	t->append(h);
	t->append(" ");
	sbar->changeItem( *t, 3);
}

void Shell::slotSetUser( QString u ) {
	QString *t = new QString( i18n(" User: ") );
	t->append(u);
	t->append(" ");
	sbar->changeItem( *t, 2);
}
void Shell::slotFileQuit(){
	saveOptions();
	close();
}

// Timer-Event wird alle 10 Sekunden angetriggert.
void Shell::timerEvent( QTimerEvent *e )
{
	enableRecentHosts();
}

void Shell::slotTabClicked( QWidget * w)
{
	m_manager->setActivePart( (KParts::Part*) w->child( "sqlguipart" ) );
	m_manager->setSelectedPart( (KParts::Part*) w->child( "sqlguipart" ) );
	createGUI( (KParts::Part*) w->child( "sqlguipart" ) );
	QString _t = tab->tabLabel( w );
	KURL* _u = new KURL( _t );
	slotSetUser( _u->user() );
	slotSetHost( _u->host() );

}

void Shell::slotRemoveActiveTab()
{
	QWidget * w = tab->currentPage();
	if(w){
		SqlGuiPart* sql = (SqlGuiPart*) w->child("sqlguipart");
		partList.removeRef( sql );
		m_manager->removePart( sql );
		tab->removePage( w );
		delete sql;
		delete w;
		if( tab->count() <= 0 ){
			fileRemoveConnection->setEnabled( false );
		}
	}
	enableRecentHosts();
}

bool Shell::addNewPart( QString label )
{
	KLibFactory *factory = KLibLoader::self()->factory( "libsqlguipart" );
	if (factory) {

		QWidget * f = new QWidget( tab, "Part-Container");
		f->setSizePolicy( QSizePolicy( QSizePolicy::Expanding, QSizePolicy::Expanding ) );
		QWhatsThis::add(  f, i18n( "QWidget f" ) );
		f->setMinimumSize( QSize::QSize(300,200) );
		QBoxLayout* l = new QBoxLayout(f,QBoxLayout::LeftToRight );
		l->setResizeMode( QLayout::Minimum );

		sqlguipart = (SqlGuiPart*) factory->create( f, "sqlguipart", "KParts::ReadOnlyPart" );
		m_sqlguipart = (KParts::ReadOnlyPart *) sqlguipart;

		sqlguipart->widget()->setSizePolicy( QSizePolicy( QSizePolicy::Expanding, QSizePolicy::Expanding ) );
		sqlguipart->widget()->show();

		connect( sqlguipart, SIGNAL( userChanged( QString ) ), this, SLOT( slotSetUser( QString ) ) );
		connect( sqlguipart, SIGNAL( hostChanged( QString ) ), this, SLOT( slotSetHost( QString ) ) );
		connect( sqlguipart, SIGNAL( connectionComplete() ), this, SLOT( slotReReadRecentHosts() ) );

		l->addWidget( sqlguipart->widget() );

		tab->addTab( f, label );
		int t_index = tab->indexOf( f );
		tab->setCurrentPage( t_index );
		m_manager->addPart( m_sqlguipart, true ); // sets as the active part

		partList.append( sqlguipart );
		fileRemoveConnection->setEnabled( true );

	} else {
		kdFatal() << "No libsqlgui found!" << endl;
		return false;
	}
	return true;
}

void Shell::slotReReadRecentHosts(){
	enableRecentHosts();
	int t = tab->count();

	// For all tabs (i.e. for all parts, i.e. for all database-connections)
	for(int i = 0; i<t; i++){
		QWidget* w = tab->page(i);

		// Get the part:
		SqlGuiPart* sql =  (SqlGuiPart*)w->child("sqlguipart") ;

		// Compose url:
		QString *u = new QString();

		// Protocoll:
		QString pr = sql->getProtocol();
		u->append( pr );
		u->append( "://");

		// If we have a username, we add it:
		QString un = sql->getUser();
		u->append( un );
		if( un.length()>0 ) u->append( "@" );

		// Add the hostname:
		u->append( sql->getHostname() );

		// If we have a basename, we add it:
		QString bn = sql->getBasename();
		if( bn.length()>0 ){
			u->append("/");
			u->append( bn );
		}

		// Status:
		// std::cout << "slotReReadRecentHosts: *u " << u->latin1() << endl;

		// An empty url looks like this:
		QString emptyurl = pr;
		emptyurl.append("://");

		// if the url is an emtpy-url, we are not connected:
		if( u->compare( emptyurl ) == 0){
			u->setLatin1("not connected");
		}

		// now set the tab-title:
		tab->setTabLabel( w, *u );
	}
}

void Shell::enableRecentHosts(){

	typedef QMap<QString, QString> RecentMap;
	RecentMap map;

	hosts->clear();

	KConfig* partconfig = new KConfig( "sqlguipartrc", false, true, "config");
	map = partconfig->entryMap("RecentFiles");
	RecentMap::Iterator it;

	for ( it = map.begin(); it != map.end(); ++it ) {
		QPixmap* p;
		QPixmap* pixon;
		QPixmap* pixoff;
		QString s = it.data();

		if( s.contains( "mysql://") > 0 ){
			pixon  = mysqlon;
			pixoff = mysqloff;
		}
		if( s.contains( "pgsql://") > 0 ){
			pixon  = pgsqlon;
			pixoff = pgsqloff;
		}

		p = pixoff;

		SqlGuiPart *sql;
		for ( sql = partList.first(); sql; sql = partList.next() ){
			if( sql->isConnected() ){

				// Compose url:
				QString *u = new QString();

				// Protocol:
				u->append( sql->getProtocol() );
				u->append( "://");

				// If username, add:
				QString un = sql->getUser();
				u->append( un );
				if ( un.length() > 0 ) u->append( "@" );

				// Add hostname
				u->append( sql->getHostname() );

				// If we have a basename, we add it:
				QString bn = sql->getBasename();
				if( bn.length()>0 ){
					u->append("/");
					u->append( bn );
				}

				if ( s.compare( *u ) == 0 ){
					p = pixon;
				}

				u->append( "/" );
				if ( s.compare( *u ) == 0 ){
					p = pixon;
				}

			}
		}
		KIconViewItem* i = new KIconViewItem( hosts, s, *p );
	}

}

void Shell::slotOpenRequest( QIconViewItem* i){
	openNewDBTab(KURL::KURL( i->text() ) );
}

void Shell::openNewDBTab(KURL _u)
{
	addNewPart( _u.prettyURL() );
	openURL( _u );
}

void Shell::slotFileNewConnection(){
	addNewPart("");
	openURL( KURL::KURL("") );
}

void Shell::slotFileNewWindow()
{
	Shell *new_window= new Shell();
	new_window->show();
}

void Shell::readOptions(){
	config->setGroup("General Options");
	QSize size=config->readSizeEntry("Geometry");

	if(!size.isEmpty()){
		resize(size);
	} else {
		resize( QSize::QSize(800,600) );
	}
}

void Shell::saveOptions(){
	config->setGroup("General Options");
	QSize sz=size();
	config->setReadOnly(false);
	config->writeEntry("Geometry", sz);
	config->sync();
}

void Shell::slotSetStausBarText( const QString & _text){
	sbar->changeItem( _text, 1 );
}

void Shell::expandToolBar(){
	KToolBar* tool = ((KMainWindow*)this)->toolBar();
	tool->setIconText( KToolBar::IconTextRight);
}

void Shell::resizeEvent( QResizeEvent * e ){

	//  int x = size().width();
	//  int a = g->width();
	//  int b = g->height();
	//  tab->resize(a,b);
	//  int x = f->width();
	////  int z = size().height();
	////  z = z - sbar->height();
	////  if( ! mbar->isTopLevelMenu() ){
	////    z = z - mbar->height();
	////  }
	//  int z = f->height();
	//  sqlguipart->widget()->resize(x ,z);


}


static KCmdLineOptions options[] = {
                                           { "+file(s)",          I18N_NOOP("Files to load"), 0 },
                                           { 0,0,0 }
                                   };


#include "sqlgui.moc"
