// -*- c++ -*-
/***************************************************************************
                          sqlgui.h  -  description
                             -------------------
    begin                : Mon Apr 29 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef SQLGUI_H
#define SQLGUI_H

#include <kparts/part.h>
#include <kparts/mainwindow.h>
#include <kparts/browserextension.h>

#include <qptrlist.h> 

class QWidget;
class QFrame; 
class SqlGuiPart;
class QSplitter;
class KIconView;
class QIconViewItem;
class QTimerEvent;
class QPixmap;
class QTabWidget;
class KAction;

class Shell : public KParts::MainWindow
{

  Q_OBJECT

public:
  Shell();
  virtual ~Shell();

  void openURL( const KURL & url );
  void openNewDBTab( KURL _u );
  KParts::BrowserExtension* mysqlBrowser;

 protected:
  void readOptions();
  void saveOptions();
  void resizeEvent(QResizeEvent * u);
  void disableThisFuckingToolBar();
  void enableRecentHosts();
  void timerEvent( QTimerEvent *e );
  bool addNewPart( QString label);
  void expandToolBar();

  public slots:
    void slotSetUser(QString u);
    void slotSetHost(QString h);
    void slotReReadRecentHosts();

  

protected slots:
  void slotFileNewWindow();
  void slotFileQuit();
  void slotSetStausBarText( const QString & _text );
  void slotOpenRequest( QIconViewItem* i );
//  void openNewDBTab( KURL _u );
  void slotTabClicked( QWidget * w);
  void slotFileNewConnection();
  void slotRemoveActiveTab();

private:
  SqlGuiPart*           sqlguipart;
  KParts::ReadOnlyPart* m_sqlguipart;
  KConfig*              config;
  KStatusBar*           sbar;
  KMenuBar*             mbar;
  KToolBar*             tbar;
//  QWidget*              f;
  QWidget*              g;
  KParts::PartManager*  m_manager;
  QSplitter*            m_splitter;
  QFrame*               hostlist;
  KIconView*            hosts;
  QPixmap*              mysqlon;
  QPixmap*              mysqloff;
  QPixmap*              pgsqlon;
  QPixmap*              pgsqloff;
  QTabWidget*           tab;

  // we need some information bout all connections we made, 
  // and also the ability to close connections.
  // (Remember: one connection = one part!!!)
  QPtrList<SqlGuiPart> partList;

  // We need to enable, disable this action under different circumstances from different methods:
  KAction * fileRemoveConnection;

};

#endif // SQLGUI_H
